#ifndef _DEBUG_CONSOLE_H_
#define _DEBUG_CONSOLE_H_

#include <Application.h>
#include <string.h>

#define DEBUGCONSOLE_START 1
#define DEBUGCONSOLE_MESSAGE 2
#define DEBUGCONSOLE_ERROR 3
#define DEBUGCONSOLE_WARNING 4
#define DEBUGCONSOLE_END 5
#define DEBUGCONSOLE_SUCCESS 6

#define DC_START 1
#define DC_MESSAGE 2
#define DC_ERROR 3
#define DC_WARNING 4
#define DC_END 5
#define DC_SUCCESS 6

class DebugConsole
{
	public :
		DebugConsole (char *ProgName)
		{
			DebugConsole = new BMessenger ("application/x-vnd.DebugConsole");
			strcpy (ProgramName, ProgName);
			SendToConsole ("Program start", DC_START);
		}
		
		~DebugConsole ()
		{
			SendToConsole ("Normal program Exit", DC_END);
		
			if (!DebugConsole)
				return;
			
			if (DebugConsole->IsValid ())
			{
				delete DebugConsole;
				DebugConsole = NULL;
			}
		}
		
		bool Check ()
		{
			if (!DebugConsole)
				return false;
				
			if (!DebugConsole->IsValid ())
				return false;
				
			return true;
		}

		void SendMessage (char *message)
		{SendToConsole (message, DC_MESSAGE);}

		void SendError (char *message)
		{SendToConsole (message, DC_ERROR);}

		void SendWarning (char *message)
		{SendToConsole (message, DC_WARNING);}

		void SendSuccess (char *message)
		{SendToConsole (message, DC_SUCCESS);}
		

	private:
		BMessenger *DebugConsole;
		char ProgramName[512];

		void SendToConsole (char *message, int type)
		{
			if (!Check ())
				return;
		
			BMessage msg (type);
			msg.AddString ("DCProgram", ProgramName);
			msg.AddString ("DCMessage", message);
			DebugConsole->SendMessage (&msg);
		}
};



#endif